---
title: XRView.eye
slug: Web/API/XRView/eye
tags:
  - API
  - AR
  - Eye
  - Property
  - Read-only
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRView
  - augmented
---
<p>{{APIRef("WebXR Device API")}}{{SecureContext_Header}}</p>

<p>The {{domxref("XRView")}} interface's read-only <code><strong>eye</strong></code> property is a string taken from the {{domxref("XREye")}} enumerated type, indicating which eye's viewpoint the <code>XRView</code> represents: <code>left</code> or <code>right</code>. For views which represent neither eye, such as monoscopic views, this property's value is <code>none</code>.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">let <em>eye</em> = <em>xrView</em>.eye;
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} whose value is one of the strings enumerated by the {{domxref("XREye")}} type:</p>

<p>{{page("/en-US/docs/Web/API/XREye", "Values")}}</p>

<h2 id="Usage_notes">Usage notes</h2>

<p>The primary purpose of this property is to allow the correct area of any pre-rendered stereo content to be presented to the correct eye. For dynamically-rendered 3D content, you can usually ignore this and render each of the viewer's views, one after another.</p>

<h2 id="Examples">Examples</h2>

<p>This code, from the viewer pose's renderer, iterates over the pose's views and renders them. <em>However</em>, we have flags which, if <code>true</code>, indicate that a particular eye has been injured during gameplay. When rendering that eye, if the flag is <code>true</code>, that view is skipped instead of being rendered.</p>

<pre class="brush: js">glLayer = xrSession.renderState.baseLayer;
gl.bindFramebuffer(gl.FRAMEBUFFER, glLayer.framebuffer);
gl.clearColor(0,0, 0, 1.0);
gl.clearDepth(1.0);
gl.clear(gl.COLOR_BUFFER_BIT, gl.DEPTH_BUFFER_BIT);

for (let view of xrPose.views) {
  let skipView = false;

  if (view.eye == "left" &amp;&amp; body.leftEye.injured) ||
    skipView = updateInjury(body.leftEye);
  } else if (view.eye == "right" &amp;&amp; body.rightEye.injured) {
    skipView = updateInjury(body.rightEye);
  }

  if (!skipView) {
    let viewport = glLayer.getViewport(view);
    gl.viewport(viewport.x, viewport.y, viewport.width, viewport.height);
    renderScene(gl, view);
  }
}</pre>

<p>For each of the views, the value of <code>eye</code> is checked and  if it's either <code>left</code> or <code>right</code>, we check to see if the <code>body.leftEye.injured</code> or <code>body.rightEye.injured</code> property is <code>true</code>; if so, we call a function <code>updateInjury()</code> on that eye to do things such as allow a bit of healing to occur, track the progress of a poison effect, or the like, as appropriate for the game's needs.</p>

<p><code>updateInjury()</code> returns <code>true</code> if the eye is still injured or <code>false</code> if the eye has been restored to health by the function,. If the result is <code>false</code>, indicating that the eye is now healthy, we render the scene for that eye. Otherwise, we don't.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#dom-xrview-eye","XRView.eye")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRView.eye")}}</div>
